/*
 *  Copyright (c) 2017, Facebook, Inc.
 *  All rights reserved.
 *
 *  This source code is licensed under the BSD-style license found in the
 *  LICENSE file in the root directory of this source tree. An additional grant
 *  of patent rights can be found in the PATENTS file in the same directory.
 *
 */

/*
 *  THIS FILE IS AUTOGENERATED. DO NOT MODIFY IT; ALL CHANGES WILL BE LOST IN
 *  VAIN.
 *
 *  @generated
 */
#pragma once

#include <functional>
#include <unordered_map>

#include <folly/Range.h>

#include <mcrouter/lib/carbon/Stats.h>

#include "mcrouter/lib/carbon/example/gen/HelloGoodbyeRouteHandleIf.h"
#include "mcrouter/lib/carbon/example/gen/HelloGoodbyeRouterStats.h"

// Forward declarations
namespace folly {
struct dynamic;
} // folly

namespace facebook {
namespace memcache {
template <class RouteHandleIf>
class RouteHandleFactory;
namespace mcrouter {
template <class RouterInfo>
class ExtraRouteHandleProviderIf;
} // mcrouter
} // memcache
} // facebook

namespace hellogoodbye {

namespace detail {

using HelloGoodbyeRoutableRequests = carbon::List<GoodbyeRequest, HelloRequest>;

} // detail

struct HelloGoodbyeRouterInfo {
  using RouteHandleIf = HelloGoodbyeRouteHandleIf;
  using RouteHandlePtr = std::shared_ptr<RouteHandleIf>;

  static constexpr const char* name = "HelloGoodbye";

  template <class Route>
  using RouteHandle = HelloGoodbyeRouteHandle<Route>;
  using RoutableRequests = detail::HelloGoodbyeRoutableRequests;

  using RouterStats = carbon::Stats<HelloGoodbyeRouterStatsConfig>;

  using RouteHandleFactoryMap = std::unordered_map<
      folly::StringPiece,
      std::function<RouteHandlePtr(
          facebook::memcache::RouteHandleFactory<RouteHandleIf>&,
          const folly::dynamic&)>,
      folly::Hash>;

  static RouteHandleFactoryMap buildRouteMap();

  static std::unique_ptr<facebook::memcache::mcrouter::
                             ExtraRouteHandleProviderIf<HelloGoodbyeRouterInfo>>
  buildExtraProvider();
};

} // hellogoodbye
